{ GnuPGSimpleInterfaceImpl.pas - GnuPG components/ interface component

 	Copyright (C) 2003 - 20xx Stephan Stapel
        (stephan.stapel@web.de)

  This file is part of gnupgcomponents, ocx package.

  GnuPGEngine and GnuPGPublickeyring is free software;
  you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}

unit GnuPGSimpleInterfaceImpl;

interface

uses
  Windows, ActiveX, Classes, Controls, Graphics, Menus, Forms, StdCtrls, SysUtils,
  ComServ, StdVCL, AXCtrls, GnuPGSimpleInterfaceControl_TLB, GnuPGInterface;

type
  TGnuPGSimpleInterface = class(TActiveXControl, IGnuPGSimpleInterface)
  private
    { Private-Deklarationen }
    FDelphiControl: TGnuPGInterface;
    FEvents: IGnuPGSimpleInterfaceEvents;
  protected
    { Protected-Deklarationen }
    procedure DefinePropertyPages(DefinePropertyPage: TDefinePropertyPage); override;
    procedure EventSinkChanged(const EventSink: IUnknown); override;
    procedure InitializeControl; override;
    function Get_Cursor: Smallint; safecall;
    function Get_DoubleBuffered: WordBool; safecall;
    function Get_Enabled: WordBool; safecall;
    function Get_Visible: WordBool; safecall;
    function Get_VisibleDockClientCount: Integer; safecall;
    procedure Set_Cursor(Value: Smallint); safecall;
    procedure Set_DoubleBuffered(Value: WordBool); safecall;
    procedure Set_Enabled(Value: WordBool); safecall;
    procedure Set_Visible(Value: WordBool); safecall;
    function encryptFile(const keyId, sourceFile,
      targetFile: WideString): WordBool; safecall;
    function signEncryptFile(const keyId, sourceFile,
      targetFile: WideString): WordBool; safecall;
    function enumPublicKeys: WordBool; safecall;
    function getNumPublicKeys: Double; safecall;
    function getPublicKeyId(index: Double): WideString; safecall;
    procedure SetGnuPGFilePath(const FilePath: WideString); safecall;
    function test: OleVariant; safecall;
  end;

implementation

uses ComObj;

{ TGnuPGSimpleInterface }

procedure TGnuPGSimpleInterface.DefinePropertyPages(DefinePropertyPage: TDefinePropertyPage);
begin
  { TODO: Hier Eigenschaftsseiten definieren. Eigenschaftsseiten werden durch
     Aufruf von DefinePropertyPage mit der Klassen-ID der Eigenschaftsseite
       definiert. Beispiel: DefinePropertyPage(Class_GnuPGSimpleInterfacePage); }
end;

procedure TGnuPGSimpleInterface.EventSinkChanged(const EventSink: IUnknown);
begin
  FEvents := EventSink as IGnuPGSimpleInterfaceEvents;
end;

procedure TGnuPGSimpleInterface.InitializeControl;
begin
  FDelphiControl := Control as TGnuPGInterface;
end;


function TGnuPGSimpleInterface.encryptFile(const keyId, sourceFile,
  targetFile: WideString): WordBool;
var f: TextFile;
begin
  AssignFile(f, 'f:\\logfile.log');
  Rewrite(f);
  Writeln(f, WideCharToString(Addr(keyId[1])));
  Writeln(f, WideCharToString(Addr(sourceFile[1])));
  Writeln(f, WideCharToString(Addr(targetFile[1])));
//  result := FDelphiControl.encryptFile(keyId, sourceFile, targetFile);

  FDelphiControl.SetGnuPGFilePath('c:\gnupg\gpg.exe');
  result := FDelphiControl.encryptFile('stephan.stapel@web.de',
                                       'f:\conceptual.zip',
                                       'f:\conceptual_encrypted.zip');

  Writeln(f, IntToStr(integer(result)));

  CloseFile(f);
end;



function TGnuPGSimpleInterface.signEncryptFile(const keyId, sourceFile,
  targetFile: WideString): WordBool;
begin
  result := FDelphiControl.signEncryptFile(keyId, sourceFile, targetFile);
end;



function TGnuPGSimpleInterface.enumPublicKeys: WordBool;
begin
  result := FDelphiControl.enumPublicKeys;
end;



function TGnuPGSimpleInterface.getNumPublicKeys: Double;
begin
  result := FDelphiControl.getNumPublicKeys;
end;



function TGnuPGSimpleInterface.getPublicKeyId(index: Double): WideString;
var i: Integer;
begin
  i      := Round(index);
  result := FDelphiControl.getPublicKeyId(i);
end;


procedure TGnuPGSimpleInterface.SetGnuPGFilePath(const FilePath: WideString);
begin
  FDelphiControl.SetGnuPGFilePath(FilePath);
end;



function TGnuPGSimpleInterface.Get_Cursor: Smallint; begin Result := Smallint(FDelphiControl.Cursor); end;
function TGnuPGSimpleInterface.Get_DoubleBuffered: WordBool; begin Result := FDelphiControl.DoubleBuffered; end;
function TGnuPGSimpleInterface.Get_Enabled: WordBool; begin Result := FDelphiControl.Enabled; end;
function TGnuPGSimpleInterface.Get_Visible: WordBool; begin Result := FDelphiControl.Visible; end;
function TGnuPGSimpleInterface.Get_VisibleDockClientCount: Integer; begin Result := FDelphiControl.VisibleDockClientCount; end;
procedure TGnuPGSimpleInterface.Set_Cursor(Value: Smallint); begin FDelphiControl.Cursor := TCursor(Value); end;
procedure TGnuPGSimpleInterface.Set_DoubleBuffered(Value: WordBool); begin FDelphiControl.DoubleBuffered := Value; end;
procedure TGnuPGSimpleInterface.Set_Enabled(Value: WordBool); begin FDelphiControl.Enabled := Value; end;
procedure TGnuPGSimpleInterface.Set_Visible(Value: WordBool); begin FDelphiControl.Visible := Value; end;

function TGnuPGSimpleInterface.test: OleVariant;
begin

end;

initialization
  TActiveXControlFactory.Create(
    ComServer,
    TGnuPGSimpleInterface,
    TGnuPGInterface,
    Class_GnuPGSimpleInterface,
    1,
    '{5C0A96D2-8ACE-4CB1-AF08-A19E5D5A364E}',
    0,
    tmApartment);
end.
